#include <stdio.h>

struct studente {
       long matricola;
       char cognome[20];
       char nome[30];
       char data[12];
       int nesami;
       float media;
       int corso;
       };

void leggi( struct studente *ps);
void inserimento(struct studente V[20],int *pn, struct studente s);
void ricerca( struct studente V[20], int n);
void visualizzacorso(struct studente V[20], int n);
void elimina( struct studente V[20], int *pn);
void visualizzameritevoli(struct studente  V[20], int k);
void ordinamento(struct studente V[20], int n);

main() {
       
  struct studente A[20],s;
  int n=0;
  int scelta;
  
  
  do {
      printf("\nScegli tra :\n");
      printf("1) Inserimento\n2)Ricerca\n");
      printf("3) Visualizza corso\n4)Elimina\n");
      printf("5) Visualizza meritevoli\n6) Ordina\n");
      printf("0) Fine\n");
      scanf("%d",&scelta);
      switch(scelta) 
      {
      case 1:  leggi(&s);
               inserimento(A,&n,s);
               break;
      case 2:  ricerca(A,n);
               break;
      case 3:  visualizzacorso(A,n);
               break;
      case 4:  elimina(A,&n);
               break;
     case 5:  visualizzameritevoli(A,n);
               break;
      case 6:  ordinamento(A,n);
               break;
      default:  ;
      
      }
      
  } while (scelta!=0);
}
  
void leggi( struct studente *ps)
{
 printf("Matricola: ");
 scanf("%ld",&(*ps).matricola);
 /*scanf("%ld",&ps->matricola); */
 printf("Corso di laurea: ");
 scanf("%d",&ps->corso);
 printf("Num esami: ");
 scanf("%d",&ps->nesami);
 printf("Cognome: ");
 scanf("%s",ps->cognome);
 printf("Media: ");
 scanf("%f",&ps->media);
}


void inserimento(struct studente V[20],int *pn, struct studente s)
{
 if(*pn==20)
     /* vettore pieno*/
     printf("Vettore pieno\n");
 else {  V[*pn]=s;
         (*pn)++;
      }
 
 }




void visualizzacorso(struct studente V[20], int n)
{
     int corso;
     int i;
     
     
     printf("Corso di laurea: (0=Civile,1=Industriale,2=Elettronica,3=Informatica)\n");
     scanf("%d",&corso);
     for(i=0;i<n;i++)
      if(V[i].corso==corso)
        {printf("Matricola: %ld\n",V[i].matricola);
         printf("Num. esami: %d\n",V[i].nesami);
        } 
}     

void elimina( struct studente V[20], int *pn)
{
 int corso,p;
 long matricola;
 int i;
 
 /* Ricerca*/
     printf("Corso di laurea: (0=Civile,1=Industriale,2=Elettronica,3=Informatica)\n");
     scanf("%d",&corso);
     printf("Matricola: ");
     scanf("%ld",&matricola);
     
     for(p=0;p<*pn;p++)
       if(V[p].matricola==matricola && V[p].corso==corso)
          break;
     
     if(p==*pn) /* L'elemento non esiste*/
      {printf("L'elemento non esiste\n");
       return;
      }
     
      /* Cancellazione*/
      for(i=p;i<*pn-1;i++)
        V[i]=V[i+1];
      (*pn)--;
 
       
}


void visualizzameritevoli(struct studente  V[20], int k)
{
     float voto;
     int i;
     
     printf("Voto: ");
     scanf("%f",&voto);
     for(i=0;i<k;i++)
        if(V[i].media>voto)
           printf("Matricola: %ld\n",V[i].matricola);
           
 }


void ordinamento(struct studente V[20], int n)
{
  int sup,i;
  struct studente temp;
  
  for(sup=n-1;sup>0;sup--)
    for(i=0;i<sup;i++)
       if(V[i].media>V[i+1].media)
         /* scambio */
         {temp=V[i];
          V[i]=V[i+1];
          V[i+1]=temp;
         } 
}


void ricerca( struct studente V[20], int n)
{
 int corso,p;
 long matricola;
 
 
 
     printf("Corso di laurea: (0=Civile,1=Industriale,2=Elettronica,3=Informatica)\n");
     scanf("%d",&corso);
     printf("Matricola: ");
     scanf("%ld",&matricola);
     
     for(p=0;p<n;p++)
       if(V[p].matricola==matricola && V[p].corso==corso)
          break;
     
     if(p==n)
         printf("L'elemento non e' stato trovato\n");
     else { printf("Num. esami: %d\n",V[p].nesami);
            printf("Media: %f\n",V[p].media);  
          }
             
 }

  
  
       
 





